package com.hai.dao;

import com.hai.entity.HighActivityPrize;
import com.hai.entity.HighActivityPrizeExample.Criteria;
import com.hai.entity.HighActivityPrizeExample.Criterion;
import com.hai.entity.HighActivityPrizeExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighActivityPrizeSqlProvider {

    public String countByExample(HighActivityPrizeExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_activity_prize");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighActivityPrizeExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_activity_prize");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighActivityPrize record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_activity_prize");
        
        if (record.getActivityAwardId() != null) {
            sql.VALUES("activity_award_id", "#{activityAwardId,jdbcType=BIGINT}");
        }
        
        if (record.getPrizeType() != null) {
            sql.VALUES("prize_type", "#{prizeType,jdbcType=INTEGER}");
        }
        
        if (record.getPrizeId() != null) {
            sql.VALUES("prize_id", "#{prizeId,jdbcType=BIGINT}");
        }
        
        if (record.getPrizeImg() != null) {
            sql.VALUES("prize_img", "#{prizeImg,jdbcType=VARCHAR}");
        }
        
        if (record.getPrizeName() != null) {
            sql.VALUES("prize_name", "#{prizeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPrizeNum() != null) {
            sql.VALUES("prize_num", "#{prizeNum,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighActivityPrizeExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("activity_award_id");
        sql.SELECT("prize_type");
        sql.SELECT("prize_id");
        sql.SELECT("prize_img");
        sql.SELECT("prize_name");
        sql.SELECT("prize_num");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_activity_prize");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighActivityPrize record = (HighActivityPrize) parameter.get("record");
        HighActivityPrizeExample example = (HighActivityPrizeExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_activity_prize");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getActivityAwardId() != null) {
            sql.SET("activity_award_id = #{record.activityAwardId,jdbcType=BIGINT}");
        }
        
        if (record.getPrizeType() != null) {
            sql.SET("prize_type = #{record.prizeType,jdbcType=INTEGER}");
        }
        
        if (record.getPrizeId() != null) {
            sql.SET("prize_id = #{record.prizeId,jdbcType=BIGINT}");
        }
        
        if (record.getPrizeImg() != null) {
            sql.SET("prize_img = #{record.prizeImg,jdbcType=VARCHAR}");
        }
        
        if (record.getPrizeName() != null) {
            sql.SET("prize_name = #{record.prizeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPrizeNum() != null) {
            sql.SET("prize_num = #{record.prizeNum,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_activity_prize");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("activity_award_id = #{record.activityAwardId,jdbcType=BIGINT}");
        sql.SET("prize_type = #{record.prizeType,jdbcType=INTEGER}");
        sql.SET("prize_id = #{record.prizeId,jdbcType=BIGINT}");
        sql.SET("prize_img = #{record.prizeImg,jdbcType=VARCHAR}");
        sql.SET("prize_name = #{record.prizeName,jdbcType=VARCHAR}");
        sql.SET("prize_num = #{record.prizeNum,jdbcType=INTEGER}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighActivityPrizeExample example = (HighActivityPrizeExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighActivityPrize record) {
        SQL sql = new SQL();
        sql.UPDATE("high_activity_prize");
        
        if (record.getActivityAwardId() != null) {
            sql.SET("activity_award_id = #{activityAwardId,jdbcType=BIGINT}");
        }
        
        if (record.getPrizeType() != null) {
            sql.SET("prize_type = #{prizeType,jdbcType=INTEGER}");
        }
        
        if (record.getPrizeId() != null) {
            sql.SET("prize_id = #{prizeId,jdbcType=BIGINT}");
        }
        
        if (record.getPrizeImg() != null) {
            sql.SET("prize_img = #{prizeImg,jdbcType=VARCHAR}");
        }
        
        if (record.getPrizeName() != null) {
            sql.SET("prize_name = #{prizeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPrizeNum() != null) {
            sql.SET("prize_num = #{prizeNum,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighActivityPrizeExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}